import algorithms.model.EDDModel;
import algorithms.model.MotifManager;
import data.Graph;
import gnu.trove.iterator.TIntIterator;
import gnu.trove.map.hash.TCustomHashMap;
import gnu.trove.set.hash.TIntHashSet;
import io.FileManager;
import util.MathUtility;

import java.io.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.math.RoundingMode;
import java.text.NumberFormat;
import java.util.*;
import java.util.stream.IntStream;

import static java.lang.Boolean.FALSE;


//prova
public class RaME {


    private static int[] sum(int[] a,int[] b) {

        int result[] = new int[a.length];
        Arrays.setAll(result, i -> a[i] + b[i]);
        return(result);
    }
    private static int[] sumArray(int[] a,int[] b) {

        int i=0;
        int[] res=new int[a.length];
        for(i=0;i<a.length;i++)
        {
            res[i]=a[i]+b[i];
        }
        //Arrays.setAll(result, i -> a[i] + b[i]);
        return(res);
    }
    public static void printVector(int[] v) {
        for (int i = 0; i < v.length; i++) {
            System.out.print(v[i] + " ");
        }
        System.out.println();
    }

    public static int signTopology(int sum_deg_motif)
    {
        if(((sum_deg_motif/2)%2)==positive)
        {
            return(1);
        }
        else
        {
            return(-1);
        }
    }

    public static void inducedProbability(int[] col_sum_motif, int[][] edges)
    {
        if(edges.length!=0) {
            double probability_extended = 0;//secondPartProbability(col_sum_motif);
            int[] sum_motif = new int[col_sum_motif.length];
            int[] index_combn = new int[edges.length];
            for (int n = 0; n < edges.length; n++) {
                index_combn[n] = n;
                sum_motif = sumArray(sum_motif, edges[n]);
            }
            //ArrayList<int[]> list_motif_plus_edges=addCombinations(col_sum_motif,edges,index_combn,index_combn.length);
            //double induced_prob=allComb(col_sum_motif,edges);
            double induced_prob = 0;
            for (int i = 0; i <= edges.length; i++)
                combinations2(col_sum_motif, edges, i, 0, new int[col_sum_motif.length]);
        }
        else
        {
            int [] null_for_sum=new int[col_sum_motif.length];
            Arrays.fill(null_for_sum, 0);
            combinations2(null_for_sum, edges, 0,0, col_sum_motif);
        }
        // int[] all_edge_motif=col_sum_motif;
        /*for(int p=0;p<edges.length;p++)
        {
            all_edge_motif=sumArray(edges[p],all_edge_motif);
        }
        list_motif_plus_edges.add(all_edge_motif);ù
        */
        //definiamo il segno positivo per la topologia di partenza
       /* positive=((IntStream.of(list_motif_plus_edges.get(list_motif_plus_edges.size()-1)).sum())/2)%2;
        for(int j=0;j<list_motif_plus_edges.size();j++)
        {
            double second_part_prob=secondPartProbability(list_motif_plus_edges.get(j));
            //System.out.println(second_part_prob);
            probability_extended+=second_part_prob;
        }
        */

        //System.out.println("Probabilità indotta:"+probability_extended);
        //return(induced_prob);
    }

    public static double secondPartProbability(int[] motif){
        int size_motif=motif.length;
        int sum_deg_motif = IntStream.of(motif).sum();
        double gamma=Math.pow(vgamma,sum_deg_motif/2);
        double prod_moments=1;
        for(int i=0;i<motif.length;i++)
        {
            //printVector(motif);
            prod_moments*=moments[motif[i]];
        }
        int sign = signTopology(sum_deg_motif);

        //System.out.println("   Sign:"+sign+"    Gamma:"+gamma+"    E.pow.D: "+prod_moments);
        return(sign*gamma*prod_moments);
    }


    static int[] colSumMotif(int[][] motif)
    {
        int[] sum_vector=new int[motif[0].length];
        for (int i=0; i < motif.length; i++) {
            for (int j=0; j < motif[0].length; j++) {
                sum_vector[j] += motif[i][j];
            }
        }
        return(sum_vector);
    }
    static int[] colSumMotif(int[] motif,int size)
    {
        int[] sum_vector=new int[size];
        for (int i=0; i < motif.length-1; i=i+size) {
            for (int j=0; j < size; j++) {
                sum_vector[j] += motif[i+j];
            }
        }
        return(sum_vector);
    }
    private static int[][] generateEdgesMatrix(int[][] motif)
    {
        int number_empty_edges=0;
        int index_edges=0;
        for(int i=0;i<motif.length;i++) {
            for (int j = i; j <motif.length; j++) {
                if ((motif[i][j] == 0)&(i!=j))
                {
                    number_empty_edges++;
                }
            }
        }
        int[][] edgesMatrix = new int[number_empty_edges][motif.length];
        for(int i=0;i<motif.length;i++) {
            int[] edges=new int[motif.length];
            // Arrays.fill(edges, 0);
            for (int j = i; j <motif.length; j++) {
                if ((motif[i][j] == 0)&(i!=j))
                {
                    Arrays.fill(edgesMatrix[index_edges], 0);
                    //edges[i]=1;
                    //edges[j]=1;
                    edgesMatrix[index_edges][i] = 1;
                    edgesMatrix[index_edges][j] = 1;
                    index_edges++;
                }
            }
        }
        return(edgesMatrix);
    }

    private static int[][] generateEdgesMatrix(int[] motif)
    {
        int number_empty_edges=0;
        for(int i=0;i<motif.length;i++) {
            //if ((motif[i] == 0)&((i%(k+1))!=0))
            if ((motif[i] == 0))
            {
                number_empty_edges++;
            }
        }
        //number_empty_edges=(number_empty_edges)/2;
        number_empty_edges=(number_empty_edges-k)/2;
        int index_edges=0;
        int index_simmetry=0;
        int[][] edgesMatrix = new int[number_empty_edges][k];
        for(int i=0;i<motif.length;i=i+k) {
            int[] edges=new int[k];
            for (int j = index_simmetry; j <k; j++) {
                if(index_edges<edgesMatrix.length) {
                    if ((motif[i + j] == 0) & ((i/k) != j)) {
                        Arrays.fill(edgesMatrix[index_edges], 0);
                        edgesMatrix[index_edges][(i / k)] = 1;
                        edgesMatrix[index_edges][j] = 1;
                        index_edges++;
                    }
                }
                else
                    break;
            }
            index_simmetry++;
        }
        return(edgesMatrix);
    }
    private static int[][] generateEdgesMatrix(int[] motif, int size_motif)
    {
        int number_empty_edges=0;
        for(int i=0;i<motif.length;i++) {
            if ((motif[i] == 0)&((i%(size_motif+1))!=0))
            {
                number_empty_edges++;
            }
        }
        number_empty_edges=number_empty_edges/2;
        int index_edges=0;
        int[][] edgesMatrix = new int[number_empty_edges][size_motif];
        for(int i=0;i<motif.length;i=i+size_motif) {
            for (int j = 0; j <size_motif; j++) {
                if(index_edges<edgesMatrix.length) {
                    if ((motif[i + j] == 0) & ((i/size_motif) != j) & ((i+j)>(i+(i/size_motif)))) {
                        Arrays.fill(edgesMatrix[index_edges], 0);
                        edgesMatrix[index_edges][i / size_motif] = 1;
                        edgesMatrix[index_edges][j] = 1;
                        index_edges++;
                    }
                }
                else
                    break;
            }
        }
        return(edgesMatrix);
    }

    private static int[] serializeMatrix(int[][] matrix)
    {
        int newArray[] = new int[matrix.length*matrix.length];
        int[] row;
        for(int i = 0; i < matrix.length; i++) {
            row = matrix[i];
            for (int j = 0; j < row.length; j++) {
                newArray[i * row.length + j] = matrix[i][j];
            }
        }
        return(newArray);
    }
    private static ArrayList<int[]> removeRedundancies(ArrayList<int[]> list)
    {
        ArrayList<int[]> new_list=new ArrayList<>();
        for(int i=0; i<list.size();i++)
        {
            for(int j=i+1; j<list.size();j++)
            {
                if(Arrays.equals(list.get(i),list.get(j)))
                {
                    list.remove(j);
                    j--;
                }
            }
        }
        return(list);
    }
    private static void generateNRPermutation(ArrayList<int[]> list_permutation,int[][] motif, int[] values, int currentValue) {
        if (currentValue == values.length + 1) {
            int[][] pmotif=permuteMotif(values, motif);
            int[] smotif=serializeMatrix(pmotif);
            //System.out.println(Arrays.toString(values));
            list_permutation.add(smotif);
        }
        for (int i = 0; i < values.length; i++) {
            if (values[i] == 0) {
                values[i] = currentValue;
                generateNRPermutation(list_permutation,motif, values, currentValue + 1);
                values[i] = 0;
            }
        }
    }


    public static long factorial(int n) {
        if (n <= 2) {
            return n;
        }
        return n * factorial(n - 1);
    }
    private static ArrayList<int[]> wrapPermutation(int[][] motif)
    {
        ArrayList<int[]> list_permutation=new ArrayList<>();
        generateNRPermutation(list_permutation,motif,new int[motif.length], 1);
        return(list_permutation);
    }


    private static int[][] permuteMotif(int[] perm, int[][] motif) {
        int[][] perm_motif=new int[motif.length][motif.length];
        for(int i=0;i<perm.length;i++)
        {
            for(int j=0;j<perm.length;j++)
            {
                perm_motif[i][j]=motif[perm[i]-1][perm[j]-1];
            }
        }
        return(perm_motif);
    }
    private static int[] orArray(int[] a1, int[] a2)
    {
        int[] resArray=new int[a1.length];
        for(int i=0;i<a1.length;i++)
        {
            resArray[i]=a1[i]|a2[i];
        }
        return(resArray);
    }
    private static ArrayList<int[]> intersections(ArrayList<int[]> nrperm_list, int size_intersection, int size_motif)
    {
        int k=size_motif;
        ArrayList<int[]> list_intersections=new ArrayList<>();
        int s=size_intersection;
        int[] new_motif;
        for(int[] motif1: nrperm_list)
        {
            for(int[] motif2: nrperm_list)
            {
                new_motif=new int[(int)Math.pow(2*k-s,2)];
                //ul supermotivo
                for(int j=0;j<k-s;j++)
                {
                    //System.out.println("j:"+j+"  k:"+k+"  s:"+s);

                    System.arraycopy(motif1, j*k, new_motif, j*(2*k-s), k);
                }
                //ur supermotivo
                for(int j=0;j<k-s;j++)
                {
                    //System.out.println("j:"+j+"  k:"+k+"  s:"+s);
                    System.arraycopy(motif1, (j*k)+k-s, new_motif, j*(2*k-s)+k-s, s);
                }
                //ultima parte formata da 0 in alto nel supermotivo
                for(int j=0;j<k-s;j++)
                {
                    Arrays.fill(new_motif,j*(2*k-s)+k,j*(2*k-s)+2*k-s,0);
                }
                for(int j=k-s;j<k;j++)
                {
                    System.arraycopy(motif1, j*k, new_motif, j*(2*k-s), k-s);
                }
                //
                // OR
                //
                int i=0;
                int sum_or=0;
                for(int j=k-s;j<k;j++)
                {
                    int[] or_vector= orArray(Arrays.copyOfRange(motif1, j*k+k-s, j*k+k),Arrays.copyOfRange(motif2, i*k, i*k+s));
                    i++;
                    System.arraycopy(or_vector, 0, new_motif, j*(2*k-s)+k-s, s);
                    sum_or+=IntStream.of(or_vector).sum();
                }
                //prima parte secondo motivo
                i=k-s;
                for(int j=0;j<s;j++)
                {
                    System.arraycopy(motif2, j*k+s, new_motif, i*(2*k-s)+k, k-s);
                    i++;
                }
                //terza riga secondo motivo riempita di 0
                for(int j=k;j<2*k-s;j++)
                {
                    Arrays.fill(new_motif,j*(2*k-s),j*(2*k-s)+k-s-1,0);
                }
                i=k;
                //terza riga secondo motivo
                for(int j=s;j<k;j++)
                {
                    System.arraycopy(motif2, j*k, new_motif, i*(2*k-s)+k-s, s);
                    i++;
                }
                i=k;
                for(int j=s;j<k;j++)
                {
                    System.arraycopy(motif2, j*k+s, new_motif, i*(2*k-s)+k, k-s);
                    i++;
                }

                i=0;
                int sum_submtx_1=0, sum_submtx_2=0;
                for(int j=k-s;j<k;j++) {

                    sum_submtx_1 += IntStream.of(Arrays.copyOfRange(motif1, j * k + k - s, j * k + k)).sum();
                    sum_submtx_2 += IntStream.of(Arrays.copyOfRange(motif2, i*k, i*k+s)).sum();
                    i++;
                }

                if((sum_submtx_1+sum_submtx_2)==(sum_or*2)) {
                    list_intersections.add(new_motif);
                    //printVector(new_motif);
                }
                //printVector(new_motif);
            }
        }


        return(list_intersections);
    }

    public static int[][] getCanonAdj(int[][] adjMatrix)
    {
        int numNodes=adjMatrix.length;
        int[] outDegrees=new int[numNodes];
        int[] inDegrees=new int[numNodes];
        int i=0, j=0, k=0;
        Vector<Integer> setAdiacs=new Vector<Integer>();
        for(i=0;i<numNodes;i++)
        {
            setAdiacs.add(i);
            for(j=0;j<numNodes;j++)
            {
                if(adjMatrix[i][j]==1)
                {
                    outDegrees[i]++;
                    inDegrees[j]++;
                }
            }
        }
        int[] canonMap=new int[numNodes];
        boolean[] used=new boolean[numNodes];
        for(i=0;i<numNodes;i++)
        {
            int maxDegOut=-1;
            int maxDegIn=-1;
            int maxId=0;
            for(j=0;j<setAdiacs.size();j++)
            {
                int idNode=setAdiacs.get(j);
                if(outDegrees[idNode]>maxDegOut)
                {
                    maxDegOut=outDegrees[idNode];
                    maxDegIn=inDegrees[idNode];
                    maxId=idNode;
                }
                else if(outDegrees[idNode]==maxDegOut)
                {
                    if(inDegrees[idNode]>maxDegIn)
                    {
                        maxDegIn=inDegrees[idNode];
                        maxId=idNode;
                    }
                }
            }
            //System.out.println(maxId);
            canonMap[i]=maxId;
            used[maxId]=true;
            setAdiacs.clear();
            for(j=0;j<=i;j++)
            {
                int idSource=canonMap[j];
                for(k=0;k<numNodes;k++)
                {
                    if(adjMatrix[idSource][k]==1 && !used[k] && !setAdiacs.contains(k))
                        setAdiacs.add(k);
                }
            }
            if(setAdiacs.isEmpty())
            {
                for(j=0;j<numNodes;j++)
                {
                    if(!used[j])
                        setAdiacs.add(j);
                }
            }
            //System.out.println(setAdiacs);
        }
        int[][] finalAdjMatrix=new int[numNodes][numNodes];
        for(i=0;i<numNodes;i++)
        {
            for(j=0;j<numNodes;j++)
                finalAdjMatrix[i][j]=adjMatrix[canonMap[i]][canonMap[j]];
        }
        return finalAdjMatrix;
    }

    public static int[] getCanonAdj(int[] adjMatrix, int size)
    {
        int length_array=adjMatrix.length;
        int numNodes=size;
        int[] outDegrees=new int[numNodes];
        int[] inDegrees=new int[numNodes];
        int i=0, j=0, k=0, m=0;
        Vector<Integer> setAdiacs=new Vector<Integer>();
        for(i=0;i<length_array;i+=size)
        {
            setAdiacs.add(m);
            for(j=0;j<numNodes;j++)
            {
                if(adjMatrix[i+j]==1)
                {
                    outDegrees[m]++;
                    inDegrees[j]++;
                }
            }
            m++;
        }
        int[] canonMap=new int[numNodes];
        boolean[] used=new boolean[numNodes];
        for(i=0;i<numNodes;i++)
        {
            int maxDegOut=-1;
            int maxDegIn=-1;
            int maxId=0;
            for(j=0;j<setAdiacs.size();j++)
            {
                int idNode=setAdiacs.get(j);
                if(outDegrees[idNode]>maxDegOut)
                {
                    maxDegOut=outDegrees[idNode];
                    maxDegIn=inDegrees[idNode];
                    maxId=idNode;
                }
                else if(outDegrees[idNode]==maxDegOut)
                {
                    if(inDegrees[idNode]>maxDegIn)
                    {
                        maxDegIn=inDegrees[idNode];
                        maxId=idNode;
                    }
                }
            }
            //System.out.println(maxId);
            canonMap[i]=maxId;
            used[maxId]=true;
            setAdiacs.clear();
            for(j=0;j<=i;j++)
            {
                int idSource=canonMap[j];
                for(k=0;k<numNodes;k++)
                {
                    if(adjMatrix[(idSource*size)+k]==1 && !used[k] && !setAdiacs.contains(k))
                        setAdiacs.add(k);
                }
            }
            if(setAdiacs.isEmpty())
            {
                for(j=0;j<numNodes;j++)
                {
                    if(!used[j])
                        setAdiacs.add(j);
                }
            }
            //System.out.println(setAdiacs);
        }
        int[] finalAdjMatrix=new int[length_array];
        for(i=0;i<numNodes;i++)
        {
            for(j=0;j<numNodes;j++)
                finalAdjMatrix[(i*size)+j]=adjMatrix[(canonMap[i]*size)+canonMap[j]];
        }
        return finalAdjMatrix;
    }
    private static BigDecimal multinomialCoefficient(int n, int[] a)
    {

        int max=0;
        int index_max=0;
        for(int i=0;i<a.length;i++)
        {
            if(a[i]>max)
            {
                max=a[i];
                index_max=i;
            }
        }
        BigDecimal result=particularFactorial(n,max);
        BigDecimal denom= new BigDecimal("1");
        for(int i=0;i<a.length;i++)
        {
            if(i!=index_max)
            {
                denom=denom.multiply(particularFactorial(a[i],0));
            }
        }
        result=result.divide(denom);
        return(result);

    }
    private static BigDecimal particularFactorial(int n,int start)
    {
        BigDecimal result=new BigDecimal("0");
        if(n>(start+1))
            result= new BigDecimal(String.valueOf(start+1));
        else
            result= new BigDecimal(String.valueOf(1));
        long i=start+2;
        while(i<=n)
        {
            result=result.multiply(new BigDecimal(i));
            i=i+1;
        }
        return(result);
    }

    private static double nonInducedProbability(int[] motif, int size)
    {
        int[] col_sum=colSumMotif(motif, size);
        /*double v1=(1/(double)((n-1)*moments[1]));
        double v2=(1/(double)(max_deg*max_deg));
        double gamma=Math.min(v1,v2);
        */
        int mpp=IntStream.of(col_sum).sum();
        double gamma_pow=Math.pow(vgamma,mpp/2);


        double E_pow_degree_final=1;
        int j;
        for(int i=0;i<col_sum.length;i++)
        {
            E_pow_degree_final*=moments[col_sum[i]];
        }
        double mu=gamma_pow*E_pow_degree_final;
        return(mu);
    }

    private static int[] frequencyArray(int [] arr)
    {
        int [] fr = new int [arr.length];
        int visited = -1;

        for(int i = 0; i < arr.length; i++){
            int count = 1;
            for(int j = i+1; j < arr.length; j++){
                if(arr[i] == arr[j]){
                    count++;
                    //To avoid counting same element again
                    fr[j] = visited;
                }
            }
            if(fr[i] != visited)
                fr[i] = count;
        }
        return(fr);
    }
    private static BigDecimal expectedMeanInduced(int[] motif, int size, double ro, BigDecimal binomial_coeff)
    {
        int[] col_sum=colSumMotif(motif,size);
        int [][] edges_motif=generateEdgesMatrix(motif);
        inducedProbability(col_sum, edges_motif);
        System.out.println("Bin.Coeff:"+binomial_coeff+"\t   ro:"+ro+"\t   induced prob:"+result_ind.toString());

        return(binomial_coeff.multiply((result_ind.multiply(BigDecimal.valueOf(ro)))));
    }


    public static long binomialCoefficient(int n, int k) {
        // take the lowest possible k to reduce computing using: n over k = n over (n-k)
        k = java.lang.Math.min( k, n - k );

        // holds the high number: fi. (1000 over 990) holds 991..1000
        long highnumber[] = new long[k];
        for (int i = 0; i < k; i++)
            highnumber[i] = n - i; // the high number first order is important
        // holds the dividers: fi. (1000 over 990) holds 2..10
        int dividers[] = new int[k - 1];
        for (int i = 0; i < k - 1; i++)
            dividers[i] = k - i;

        // for every divider there always exists a highnumber that can be divided by
        // this, the number of highnumbers being a sequence that equals the number of
        // dividers. Thus, the only trick needed is to divide in reverse order, so
        // divide the highest divider first trying it on the highest highnumber first.
        // That way you do not need to do any tricks with primes.
        for (int divider: dividers)
            for (int i = 0; i < k; i++)
                if (highnumber[i] % divider == 0) {
                    highnumber[i] /= divider;
                    break;
                }

        // multiply remainder of highnumbers
        long result = 1;
        for (long high : highnumber)
            result *= high;
        return result;
    }


    private static BigDecimal binomial(int n, int k)
    {
        if (k>n-k)
            k=n-k;

        BigDecimal b=new BigDecimal("1");
        int m=n;
        for (int i=1; i<=k; i++ ) {
            m=n;
            b = (b.multiply(BigDecimal.valueOf(m))).divide(BigDecimal.valueOf(i),2, RoundingMode.HALF_UP);
            m--;
        }
        return b;
    }

    private static ArrayList<int[]> expandMotif(int[] motif, int i)
    {

        int[] tmp_motif=new int[motif.length];//=motif;
        int inters_motif_size=2*k-i;
        //riempiamo la matrice di 1 (dove appaiono le matrici che formano l'intersezione)
        for(int j=0;j<(inters_motif_size*k);j=j+inters_motif_size)
        {
            for(int l=0;l<k;l++)
            {
                tmp_motif[j+l]=1;
            }
        }
        for(int j=motif.length-(inters_motif_size*k);j<motif.length;j=j+inters_motif_size)
        {
            for(int l=inters_motif_size-k;l<inters_motif_size;l++)
            {
                tmp_motif[j+l]=1;
            }
        }
        int [][] edge_matrix=generateEdgesMatrix(tmp_motif, inters_motif_size);
        int[] index_combn=new int[edge_matrix.length];
        for(int n=0;n<edge_matrix.length;n++)
        {
            index_combn[n]=n;
        }
        //trasformazione del vettore motif in un vettore dei gradi dei nodi
        motif=colSumMotif(motif,2*k-i);
        ArrayList<int[]> list_motif_plus_edges= addCombinations(motif,edge_matrix,index_combn,index_combn.length);
        int[] all_edge_motif=motif;
        for(int p=0;p<edge_matrix.length;p++)
        {
            all_edge_motif=sumArray(edge_matrix[p],all_edge_motif);
        }
        list_motif_plus_edges.add(all_edge_motif);
        //System.out.println("Length list motif expanded:"+list_motif_plus_edges.size());
        return(list_motif_plus_edges);
    }
    private static int[][] expandEdgesMatrix(int[][] edges)
    {
        if(edges.length!=0) {
            int length_edge = edges[0].length;
            int[][] new_matrix = new int[edges.length][(int) Math.pow(length_edge, 2)];
            int count = 0;
            int tmp = 0;
            for (int i = 0; i < edges.length; i++) {
                count = 0;
                for (int j = 0; j < length_edge; j++) {
                    if (edges[i][j] == 1) {
                        count++;
                        if (count == 2) {
                            new_matrix[i][(tmp * length_edge) + j] = 1;
                            new_matrix[i][(j * length_edge) + tmp] = 1;
                        }
                        tmp = j;
                    } else {
                        new_matrix[i][j] = 0;
                    }
                }
            }
            return (new_matrix);
        }
        else
            return(null);
    }
    private static ArrayList<int[]> expandAdjacencyMatrix(int[] motif, int i)
    {

        int[] tmp_motif=new int[motif.length];//=motif;
        int inters_motif_size=2*k-i;
        //riempiamo la matrice di 1 (dove appaiono le matrici che formano l'intersezione)
        for(int j=0;j<(inters_motif_size*k);j=j+inters_motif_size)
        {
            for(int l=0;l<k;l++)
            {
                tmp_motif[j+l]=1;
            }
        }
        for(int j=motif.length-(inters_motif_size*k);j<motif.length;j=j+inters_motif_size)
        {
            for(int l=inters_motif_size-k;l<inters_motif_size;l++)
            {
                tmp_motif[j+l]=1;
            }
        }
        int [][] edge_matrix=generateEdgesMatrix(tmp_motif, inters_motif_size);
        int [][] edge_expanded=expandEdgesMatrix(edge_matrix);
        if(edge_expanded!=null) {
            int[] index_combn = new int[edge_expanded.length];
            for (int n = 0; n < edge_expanded.length; n++) {
                index_combn[n] = n;
            }
            //trasformazione del vettore motif in un vettore dei gradi dei nodi
            //motif=colSumMotif(motif,2*k-i);
            ArrayList<int[]> list_motif_plus_edges = addCombinations(motif, edge_expanded, index_combn, index_combn.length);
            int[] all_edge_motif = motif;
            for (int p = 0; p < edge_expanded.length; p++) {
                all_edge_motif = sumArray(edge_expanded[p], all_edge_motif);
            }
            //printVector(all_edge_motif);
            list_motif_plus_edges.add(all_edge_motif);
            //System.out.println("Length list motif expanded:"+list_motif_plus_edges.size());
            return (list_motif_plus_edges);
        }
        //per le clique
        else {
            ArrayList<int[]> list_motif_plus_edges=new ArrayList<>();
            list_motif_plus_edges.add(motif);
            return (list_motif_plus_edges);
        }
    }
    static ArrayList<int[]> addCombinations(int[] motif,int[][] edges,int[] sequence, int N)
    {
        ArrayList<int[]> list_motif_plus_edges=new ArrayList<>();
        int[] data = new int[N];
        for (int r = 0; r < sequence.length; r++)
            combinations(motif,list_motif_plus_edges,edges,sequence, data, 0, N - 1, 0, r);
        return(list_motif_plus_edges);
    }
    static void combinations(int[] motif,ArrayList<int[]> list, int[][] edges,int[] sequence, int[] data, int start, int end,
                             int index, int r)
    {

        if (index == r)
        {
            int[] res_sum=motif;
            for (int j = 0; j < r; j++)
            {
                res_sum=sumArray(edges[data[j]],res_sum);
            }
            list.add(res_sum);
        }

        for (int i = start; i <= end && ((end - i + 1) >= (r - index)); i++)
        {
            data[index] = sequence[i];
            combinations(motif, list, edges,sequence, data, i + 1, end, index + 1, r);
        }
    }





    private static double secondPartVariance(int[] intersection, int size_intersection)
    {
        ArrayList<int[]> expand_motif_intersection=expandAdjacencyMatrix(intersection, size_intersection);
        System.out.println("-----Number expanded motif:" + expand_motif_intersection.size());
        for (int i = 0; i < expand_motif_intersection.size(); i++) {
            //printVector(expand_motif_intersection.get(i));
        }
        double second_part_probability = 0;
        int[] col_sum_motif;
        int[] canonical_motif=new int[2*k-size_intersection];
        Integer motif_hashcode=0;
        double ind_prob=0;
        for (int i = 0; i < expand_motif_intersection.size(); i++) {
            canonical_motif=getCanonAdj(expand_motif_intersection.get(i),2*k-size_intersection);
            motif_hashcode=Arrays.hashCode(canonical_motif);
            //System.out.println(motif_hashcode);
            if(motifMap.containsKey(motif_hashcode)) {
                // Get the value assigned to a given key in the HashMap
                ind_prob = motifMap.get(motif_hashcode);
            } else {
                int[][] edges_motif = generateEdgesMatrix(expand_motif_intersection.get(i), 2 * k - size_intersection);
                //System.out.println(Math.pow(2,edges_motif.length));
                col_sum_motif = colSumMotif(expand_motif_intersection.get(i), 2 * k - size_intersection);
                inducedProbability(col_sum_motif, edges_motif);
                //System.out.println("ind prob: " +ind_prob);
                motifMap.put(motif_hashcode, ind_prob);
            }

            second_part_probability += ind_prob;
            //second_part_probability+=secondPartProbability(expand_motif_intersection.get(i));
            //System.out.println("---Induced Probability: " + second_part_probability);

        }
        return ( second_part_probability);

    }

    public static void element(char[] result, int offset, int length) {
        System.out.println(new String(result, offset, length));
    }
    private static void generate(char[] input) {
        char[] result = new char[input.length];
        int[] index = new int[input.length];

        // initialize the arrays.
        System.arraycopy(input,0,result,0,input.length);
        Arrays.fill(index, 0, index.length, 0);

        // loop over the output lengths.

        for (int length = min; length <= max; length++) {
            int updateIndex = 0;
            do {
                element(result, 0, length);

                // update values that need to reset.
                for(updateIndex=length-1; updateIndex != -1 && ++index[updateIndex] == input.length;)
                {
                    result[updateIndex] = input[0];
                    index[updateIndex] = 0;
                    updateIndex--;
                }


                // update the character that is not resetting, if valid
                if (updateIndex != -1)
                    result[updateIndex] = input[index[updateIndex]];
            }
            while (updateIndex != -1);
        }
    }

    public static double allComb(int[] motif, int[][] edges) {
        BitSet bs = new BitSet();
        int[] res_sum=motif;
        int[] tmp=motif;
        double second_part_prob=0, probability_extended=0;
        int num_absent_edges=edges.length;
        positive=((IntStream.of(motif).sum())/2)%2;

        while (bs.length() <= num_absent_edges) {

            int pos = bs.nextClearBit(0);
            bs.flip(0, pos + 1);

            for (int j = bs.nextSetBit(0); j >= 0 && j<num_absent_edges; j = bs.nextSetBit(j+1)) {

                res_sum = sumArray(edges[j], res_sum);

                //res_sum=tmp;
            }

            second_part_prob=secondPartProbability(res_sum);
            probability_extended+=second_part_prob;
            res_sum=motif;
        }
        return(probability_extended);
    }


    public static BigDecimal sqrt(BigDecimal number, RoundingMode rounding)
    {
        return sqrt(number, BigDecimalONE, rounding);
    }

    public static BigDecimal sqrt(BigDecimal number, BigDecimal guess, RoundingMode rounding)
    {
        BigDecimal result = BigDecimalZERO;
        BigDecimal flipA = result;
        BigDecimal flipB = result;
        boolean first = true;
        while( result.compareTo(guess) != 0 )
        {
            if(!first)
                guess = result;
            else
                first=false;

            result = number.divide(guess, rounding).add(guess).divide(BigDecimalTWO, rounding);
            // handle flip flops
            if(result.equals(flipB))
                return flipA;

            flipB = flipA;
            flipA = result;
        }
        return result;
    }

    static long top=0;
    static BigDecimal result_ind= new BigDecimal(0);
    static void combinations2(int[] motif, int[][] edges, int len, int startPosition, int[] result){
        //System.out.println("out:"+result_ind.toString());
        if (len == 0){
            result =sumArray(motif, result);
            //System.out.println(Arrays.toString(result));
            BigDecimal sec_prob = new BigDecimal(0);
            sec_prob= BigDecimal.valueOf(secondPartProbability(result));
            result_ind=result_ind.add((sec_prob));
            //System.out.println("after:"+result_ind.toString());
            top++;
            return;
        }
        for (int i = startPosition; i <= edges.length-len; i++){
            int[] prec_motif =result;
            result =sumArray(edges[i], result);
            combinations2(motif,  edges, len-1, i+1, result);
            result=prec_motif;
        }
    }

    public static void printHelp()
    {
        String help = "Usage: java RaME -i <networkFile> -t <topologyFile> [-o <outputFile>]\n\n";
        help+="See file readme.txt in \"src\" folder for further informations\n";
        help+="REQUIRED PARAMETERS:\n";
        help+="-i\tText file of the input network formatted as edge list placed into the folder \"Networks\"\n";
        help+="-t\tText file representing the adjacency matrix for the query graph placed into the folder \"Topologies\" (only undirected subgraphs)\n";
        help+="-o\tOutput file where results will be saved (If omitted result will be saved as \"networkFile-topologyFile.txt\" into folder \"Results\")\n\n";
        help+="AN EXAMPLE:\n";
        help+="java RaME -i humanprotein.txt -t query3.txt -o HP-Q3.txt\n";
        help+="Run RaME on network humanprotein.txt for topology query3.txt and push the results in a file HP-Q3.txt \n(all the files are already existing in folders \"Networks\", \"Topologies\" and \"Results\" respectively)\n";
        System.out.println(help);
    }

    protected static BigDecimal BigDecimalZERO = BigDecimal.ZERO;
    protected static BigDecimal BigDecimalONE = BigDecimal.ONE;
    protected static BigDecimal BigDecimalTWO = new BigDecimal(2);
    protected static BigDecimal BigDecimalFOUR = new BigDecimal(4);
    protected static int min=1,max=3;
    protected static int positive;
    protected static double vgamma;
    protected  static int k;
    protected static int max_deg,n;
    protected static double[] moments;;
    protected  static Map<Integer, Double> motifMap = new HashMap<>();
    public static void main(String[] args) throws IOException {
        long startTime1 = System.nanoTime();
        /*long start1 = System.nanoTime();

        allComb(33);

        long endTime1 = System.nanoTime();
        long dur1 = (endTime1 - start1)/1000000000 ;
        System.out.println("tempo:"+dur1);
*/

        String inputFile=null;
        String outputFile=null;
        String topology=null;
        int topologySize=0;
        int i=0;
        for (i=0;i<args.length;i++)
        {
            if(args[i].equals("-i"))
                inputFile=args[++i];
            else if(args[i].equals("-s"))
                topologySize=Integer.parseInt(args[++i]);
            else if(args[i].equals("-t"))
                topology=args[++i];
            else if(args[i].equals("-o"))
                outputFile=args[++i];
            else
            {
                System.out.println("Error! Unrecognizable command '" + args[i] + "'");
                printHelp();
                System.exit(1);
            }
        }

        if(inputFile==null)
        {
            System.out.println("Error! No input network has been specified!\n");
            printHelp();
            System.exit(1);
        }
        else if (topology==null){
            System.out.println("Error! No query graph has been specified!\n");
            printHelp();
            System.exit(1);
        }

        String network_file=inputFile;
        String path=System.getProperty("user.dir");
        String pathTopology=path+"/Topologies/"+topology;
        String outputfile="";
        if(outputFile==null)
            outputfile=path+"/Results/"+inputFile.substring(0,((inputFile.length()-4)))+"-"+topology;
        else
            outputfile=path+"/Results/"+outputFile;
        FileWriter writer=new FileWriter(outputfile);

        File file = new File(pathTopology);
        BufferedReader br = new BufferedReader(new FileReader(file));
        br.mark(0);
        int rows = 0;
        String st;
        writer.write("Query graph:\n");
        while ((st = br.readLine()) != null) {
            rows++;
            System.out.println(st);
            writer.write(st+"\n");

        }
        writer.write("\n");

        // pre-read in the number of rows/columns
        int columns = rows;
        int[][] adjTopo = new int[rows][columns];
// read in the data
        int f=0;
        br = new BufferedReader(new FileReader(file));
        while ((st = br.readLine()) != null) {
            for(int j = 0; j < columns; ++j)
            {
                adjTopo[f][j] = Integer.parseInt(String.valueOf(st.charAt(j)));
            }
            f++;
        }


                long startTime = System.nanoTime();

                k = adjTopo.length;
                int motifSize = adjTopo.length;
                String networkfile = inputFile;
                //System.out.println("\nNETWORK NAME:" + networkfile + "    SIZE:" + motifSize);

                String netFile = path+"/Networks/"  + networkfile;

                boolean directed = FALSE;
                boolean induced = FALSE;
                System.out.println("Reading graph file...");
                FileManager fm = new FileManager();
                Graph net = fm.readGraph(netFile);
                //System.out.println("Reading motif topologies...");
                MotifManager mm = new MotifManager(motifSize, directed, induced);
                //TCustomHashMap<boolean[][], Integer> mapTopoPositions = fm.buildCompleteTopoSet(motifSize, directed);
                //System.out.println("Filtering motif topologies according to user constraints...");
                String topoConstrFile = null;
                //Vector<Graph> setTopologies = fm.readMotifs(topoConstrFile, directed, mapTopoPositions);
                EDDModel edd = mm.setupEDDModel(net);
                int minFreq = 1;
                //long[] freqsMotifs = mm.censusGraph(net, setTopologies, minFreq);

                n = net.getNumNodes();
                k = motifSize;
                max_deg = net.getMaxDegOut();
                moments = edd.getMomentsOut();
                vgamma = Math.min((1 / (double) ((n - 1) * moments[1])), (1 / (double) (max_deg * max_deg)));


                double binomCoeff = MathUtility.binomCoeff(n, k);
                //System.out.println("Coefficiente binomiale: "+binomCoeff);
                BigDecimal induced_mean = new BigDecimal(0);

                int[] sum_motif = colSumMotif(adjTopo);
                positive = ((IntStream.of(sum_motif).sum()) / 2) % 2;
                ArrayList<int[]> perm_motif = wrapPermutation(adjTopo);
                ArrayList<int[]> NRperm_motif = removeRedundancies(perm_motif);
                int[] serialized_motif = serializeMatrix(adjTopo);
                double ro = NRperm_motif.size();
                //BigDecimal result_ind= new BigDecimal(1);

                induced_mean = expectedMeanInduced(serialized_motif, k, ro, BigDecimal.valueOf(binomCoeff));
                //result_ind = new BigDecimal(0);
                //System.out.println("");
                System.out.println("Induced mean: "+induced_mean);

                long endTime = System.nanoTime();
                long duration = (endTime - startTime); //in ms
                double duration_s = (double) duration / 1000000000; //in s
                //System.out.println("Esecuzione in: "+duration_s + " secondi");

                //System.out.println("binom.coeff:"+binomialCoefficient(n,k));
                System.out.println("Results in:"+outputfile);
                //FileWriter writer=new FileWriter(outputfile);
                writer.write("Induced mean: "+induced_mean+"\n");
                writer.write("Execution time (s): "+ duration_s);
                writer.close();

    }
}
